## mono 6.14.1+ds

=== mcs/errors/Makefile ===
thisdir = errors
SUBDIRS = 
include ../build/rules.make

DISTFILES = \
	CONTRIBUTORS_README 	\
	errors.txt 		\
	$(wildcard *.cs)	\
	$(wildcard *.il)	\
	$(wildcard *.inc)	\
	$(wildcard *.pub)	\
	$(wildcard *.snk)	\
	$(wildcard *.response)	\
	$(wildcard known-issues-*)	\
	$(wildcard dlls/first/*.cs)	\
	$(wildcard dlls/second/*.cs)

TEST_SUPPORT_FILES = \
	CS0012-lib.dll CS0012-2-lib.dll CS0012-3-lib.dll CS0012-4-lib.dll CS0012-5-lib.dll CS0012-6-lib.dll CS0012-9-lib.dll CS0012-10-lib.dll CS0012-11-lib.dll CS0012-12-lib.dll CS0012-13-lib.dll CS0012-14-lib.dll CS0012-15-lib.dll CS0012-16-lib.dll CS0012-17-lib.dll CS0012-18-lib.dll CS0012-21-lib.dll CS0012-22-lib.dll CS0012-23-lib.dll CS0012-24-lib.dll CS0019-71-lib.dll CS0029-26-lib.dll \
	CS0103-2-lib.dll CS0118-2-lib.dll CS0122-8-lib.dll CS0122-10-lib.dll CS0122-14-lib.dll CS0122-15-lib.dll CS0122-19-lib.dll CS0122-35-lib.dll CS0122-36-lib.dll CS0122-38-lib.dll CS0143-lib.dll CS0144-3-lib.dll CS0165-19-lib.dll CS0165-51-lib.dll \
	CS0205-3-lib.dll CS0246-29-lib.dll CS0229-3-lib.dll CS0229-4-lib.dll CS0266-25-lib.dll \
	CS0315-2-lib.dll \
	CS0425-7-lib.dll CS0433-lib.dll CS0433-2-lib.dll \
	CS0506-3-lib.dll CS0507-7-lib.dll CS0507-8-lib.dll CS0534-3-lib.dll CS0534-4-lib.dll CS0534-6-lib.dll CS0571-3-lib.dll CS0571-5-lib.dll CS0571-6-lib.dll \
	CS0612-2-lib.dll CS0618-2-lib.dll CS0619-8-lib.dll CS0619-17-lib.dll CS0619-32-lib.dll CS0619-33-lib.dll CS0619-36-lib.dll CS0619-42-lib.dll \
	CS0619-43-lib.dll CS1546-lib.dll CS0619-51-lib.dll CS1509-module.dll CS1681-2-lib.dll \
	CS0730-lib.dll CS0731-1-lib.dll CS0731-2-lib.dll \
	CS1070-lib.dll \
	CS1540-15-lib.dll CS1540-17-lib.dll CS1542-lib.dll CS1577-lib.dll \
	CS1683-lib.dll CS1685-2-lib.dll \
	dlls/first/CS1701-lib.dll dlls/second/CS1701-lib.dll CS1701-lib.dll dlls/first/CS1702-lib.dll dlls/second/CS1702-lib.dll CS1702-lib.dll dlls/first/CS1705-lib.dll dlls/second/CS1705-lib.dll CS1705-lib.dll \
	CS2015-lib.dll CS3005-16-lib.dll CS3013-module.dll CSExternAlias-lib.dll \
	CS7069-lib.dll \
	CS8009-lib.dll \
	CSFriendAssembly-lib.dll \
	dlls/first/CS1704-lib.dll \
	dlls/second/CS1704-lib.dll \
	dlls/cs1703-2/System.dll

-include $(mcs_topdir)/build/config.make

# mention all targets
all-local $(STD_TARGETS:=-local):

VALID_TEST_PROFILE := $(filter net_4_x, $(PROFILE))
ifdef VALID_TEST_PROFILE

qcheck: run-mcs-tests 

run-test-local: test-local qcheck

check: run-test-local

# Required to test parser correctly
# -compiler-options:-v

TEST_PATTERN = 'v4'
TESTER_OPTIONS = -compiler-options:"-v --break-on-ice -d:NET_4_0;NET_4_5"

COMPILER = $(topdir)/class/lib/$(PROFILE)/mcs.exe
TESTER = MONO_RUNTIME='$(RUNTIME)' $(TEST_RUNTIME) $(TEST_RUNTIME_FLAGS) $(LOCAL_RUNTIME_FLAGS) $(topdir)/class/lib/$(PROFILE)/compiler-tester.exe

test-local: $(TEST_SUPPORT_FILES)

test-bundle:
	mkdir -p $(TEST_BUNDLE_PATH)/tests/mcs-errors
	cp -L -R dlls $(TEST_BUNDLE_PATH)/tests/mcs-errors/
	cp -L *.cs *.inc *.dll *.snk *.pub $(TEST_BUNDLE_PATH)/tests/mcs-errors/
	cp -L $(topdir)/class/lib/$(PROFILE)/compiler-tester.* $(TEST_BUNDLE_PATH)/tests/mcs-errors/
	cp -L known-issues-$(PROFILE) $(TEST_BUNDLE_PATH)/tests/mcs-errors/known-issues-$(PROFILE)

run-mcs-tests: test-local
	$(TESTER) -mode:neg -files:$(TEST_PATTERN) -compiler:$(COMPILER) -reference-dir:$(topdir)/class/lib/$(PROFILE) -issues:known-issues-$(PROFILE) -log:$(PROFILE).log $(TESTER_OPTIONS) $(TOPTIONS)

endif

clean-local:
	rm -f *.exe *.dll *.log *.mdb dummy.xml *.junk dlls/first/*.dll dlls/second/*.dll

dist-local: dist-default

nstall-local uninstall-local:

CS0029-26-lib.dll : CS0029-26-lib.cs
	$(CSCOMPILE) /r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/mscorlib.dll /target:library /publicsign /keyfile:key.snk /out:$@ $<

CS0266-25-lib.dll: CS0266-25-lib.cs
	$(CSCOMPILE) /r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/mscorlib.dll /target:library /r:$(topdir)/class/lib/$(PROFILE)/System.Core.dll /out:$@ $<

dlls/first/CS1701-lib.dll: dlls/first/CS1701-lib.cs
	$(CSCOMPILE) /r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/mscorlib.dll /target:library /warn:0 /publicsign /keyfile:key.snk /out:$@ $<

dlls/first/CS1702-lib.dll: dlls/first/CS1702-lib.cs
	$(CSCOMPILE) /r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/mscorlib.dll /target:library /warn:0 /publicsign /keyfile:key.snk /out:$@ $<

dlls/first/CS1703-lib.dll: dlls/first/CS1703-lib.cs
	$(CSCOMPILE) /r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/mscorlib.dll /target:library /warn:0 /publicsign /keyfile:key.snk /out:$@ $<

dlls/first/CS1705-lib.dll: dlls/first/CS1705-lib.cs
	$(CSCOMPILE) /r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/mscorlib.dll /target:library /warn:0 /publicsign /keyfile:key.snk /out:$@ $<

dlls/second/CS1701-lib.dll: dlls/second/CS1701-lib.cs
	$(CSCOMPILE) /r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/mscorlib.dll /target:library /warn:0 /publicsign /keyfile:key.snk /out:$@ $<

dlls/second/CS1702-lib.dll: dlls/second/CS1702-lib.cs
	$(CSCOMPILE) /r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/mscorlib.dll /target:library /warn:0 /publicsign /keyfile:key.snk /out:$@ $<

dlls/second/CS1703-lib.dll: dlls/second/CS1703-lib.cs
	$(CSCOMPILE) /r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/mscorlib.dll /target:library /warn:0 /publicsign /keyfile:key.snk /out:$@ $<

dlls/second/CS1705-lib.dll: dlls/second/CS1705-lib.cs
	$(CSCOMPILE) /r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/mscorlib.dll /target:library /warn:0 /publicsign /keyfile:key.snk /out:$@ $<

dlls/cs1703-2/System.dll: $(topdir)/../external/binary-reference-assemblies/v2.0/System.dll
	mkdir -p $(dir $@)
	cp $< $@

CS1701-lib.dll : CS1701-lib.cs dlls/first/CS1701-lib.dll
	$(CSCOMPILE) /r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/mscorlib.dll /target:library /warn:0 /r:dlls/first/CS1701-lib.dll /out:$@ $<

CS1702-lib.dll : CS1702-lib.cs dlls/first/CS1702-lib.dll
	$(CSCOMPILE) /r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/mscorlib.dll /target:library /warn:0 /r:dlls/first/CS1702-lib.dll /out:$@ $<

CS1705-lib.dll : CS1705-lib.cs dlls/first/CS1705-lib.dll
	$(CSCOMPILE) /r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/mscorlib.dll /target:library /warn:0 /r:dlls/first/CS1705-lib.dll /out:$@ $<

CSFriendAssembly-lib.dll : CSFriendAssembly-lib.cs
	$(CSCOMPILE) /r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/mscorlib.dll /target:library /publicsign /keyfile:key.snk /warn:0 /out:$@ $<

%-lib.dll: %-lib.cs
	$(CSCOMPILE) /r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/mscorlib.dll /target:library /warn:0 /out:$@ $<

%-module.dll: %-module.cs
	$(CSCOMPILE) /r:$(topdir)/class/lib/$(PROFILE_DIRECTORY)/mscorlib.dll /target:module /out:$@ $<

%-lib.dll: %-lib.il
	$(ILASM) /dll /out:$@ $<

=== samples/size/Makefile ===

all: objectinspector.dll libmono-profiler-size.so sample.exe
	LD_LIBRARY_PATH=. mono --profile=size sample.exe

sample.exe: objectinspector.dll sample.cs
	mcs -r:objectinspector.dll sample.cs 

objectinspector.dll: objectinspector.cs
	mcs -target:library objectinspector.cs

libmono-profiler-size.so: size.c
	gcc -Wall -g -shared -o libmono-profiler-size.so size.c `pkg-config --cflags --libs mono`

=== external/api-doc-tools/mdoc/Makefile ===
CONFIGURATION = Release
PROGRAM = ../bin/$(CONFIGURATION)/mdoc.exe
MONO = mono
CSCOMPILE = mcs
VBCOMPILE = vbnc
TEST_CSCFLAGS = -target:library

MDOC_COMMON_FLAGS = \
	/resource:../../class/monodoc/Resources/mdoc-html-format.xsl,mdoc-html-format.xsl    \
	/resource:../../class/monodoc/Resources/mdoc-html-utils.xsl,mdoc-html-utils.xsl      \
	/resource:../../class/monodoc/Resources/mdoc-sections-css.xsl,mdoc-sections-css.xsl  \
	/resource:../../class/monodoc/Resources/mono-ecma-css.xsl,mono-ecma-css.xsl          \
	/resource:Resources/defaulttemplate.xsl,defaulttemplate.xsl                 \
	/resource:Resources/monodoc-ecma.xsd,monodoc-ecma.xsd                       \
	/resource:Resources/msitomsx.xsl,msitomsx.xsl                               \
	/resource:Resources/overview.xsl,overview.xsl                               \
	/resource:Resources/stylesheet.xsl,stylesheet.xsl                           \


MONODOC_RESOURCES = \
	../../class/monodoc/Resources/mdoc-html-utils.xsl    \
	../../class/monodoc/Resources/mdoc-sections-css.xsl  \
	../../class/monodoc/Resources/mono-ecma-css.xsl

MDOC_RESOURCES = \
	Resources/defaulttemplate.xsl     \
	Resources/monodoc-ecma.xsd        \
	Resources/msitomsx.xsl            \
	Resources/overview.xsl            \
	Resources/stylesheet.xsl

MDOC_TEST_FILES = \
	Test/CLILibraryTypes.dtd				  \
	Test/DocTest-v1.cs                                        \
	Test/DocTest-v2.patch                                     \
	Test/msxdoc-expected.importslashdoc.xml                   \
	Test/TestEcmaDocs.xml                                     \
	Test/validate.check.monodocer                             \
	Test/validate.check.monodocer.importslashdoc              \
	Test/validate.check.monodocer.since

EXTRA_DISTFILES = \
	$(MDOC_RESOURCES) \
	$(MDOC_TEST_FILES)

MULTI-CLASSIC = Test/DocTest-DropNS-classic.dll Test/DocTest-DropNS-classic-multitest.dll
MULTI-UNIFIED = Test/DocTest-DropNS-unified.dll Test/DocTest-DropNS-unified-multitest.dll

DIFF = diff -rup
DIFF_QUIET = diff --brief
ifeq ($(PLATFORM), win32)
DIFF = diff -rupZ
DIFF_QUIET = diff --brief -Z
endif

cleanup:
	-rm -Rf Test/en.actual Test/html.actual

nunit: 
	mono ../packages/NUnit.ConsoleRunner.3.6.0/tools/nunit3-console.exe mdoc.Test/bin/$(CONFIGURATION)/mdoc.Test.dll

Test/DocTest-VB-Eii.dll:
	$(VBCOMPILE) -out:Test/DocTest-VB-Eii.dll  Test/ClassEnumerator.vb
	
Test/DocTest-addNonGeneric.dll:
	$(CSCOMPILE) $(TEST_CSCFLAGS) -unsafe -debug -optimize -target:library -out:$@ Test/DocTest-addNonGeneric.cs

Test/DocTest-addNonGeneric-v2.dll:
	$(CSCOMPILE) $(TEST_CSCFLAGS) -unsafe -debug -optimize -target:library -out:$@ Test/DocTest-addNonGeneric.cs /define:V2

Test/DocTest-DropNS-classic-secondary.dll:
	@echo $(value @)
	$(CSCOMPILE) $(TEST_CSCFLAGS) -unsafe -debug -optimize -target:library -out:$@ Test/DocTest-DropNS-classic-secondary.cs -doc:Test/DocTest-DropNS-classic-secondary.xml

Test/DocTest-DropNS-classic.dll:
	@echo $(value @)
	$(CSCOMPILE) $(TEST_CSCFLAGS) -unsafe -debug -optimize -target:library -out:$@ Test/DocTest-DropNS-classic.cs -doc:Test/DocTest-DropNS-classic.xml

Test/DocTest-DropNS-unified.dll:
	$(CSCOMPILE) $(TEST_CSCFLAGS) -unsafe -debug -optimize -target:library -out:$@ Test/DocTest-DropNS-unified.cs

Test/DocTest-DropNS-unified-multitest.dll:
	rm -f $@
	$(CSCOMPILE) $(TEST_CSCFLAGS) -unsafe -debug -optimize -target:library -out:$@ Test/DocTest-DropNS-unified.cs /define:MULTITEST

Test/DocTest-DropNS-classic-multitest.dll:
	rm -f $@
	$(CSCOMPILE) $(TEST_CSCFLAGS) -unsafe -debug -optimize -target:library -out:$@ Test/DocTest-DropNS-classic.cs /define:MULTITEST

Test/DocTest-DropNS-unified-deletetest.dll:
	rm -f Test/DocTest-DropNS-unified-deletetest.dll
	$(CSCOMPILE) $(TEST_CSCFLAGS) -unsafe -debug -optimize -target:library -out:$@ Test/DocTest-DropNS-unified.cs /define:DELETETEST

Test/DocTest-DropNS-unified-deletetest-V2.dll:
	rm -f Test/DocTest-DropNS-unified-deletetest.dll
	$(CSCOMPILE) $(TEST_CSCFLAGS) -unsafe -debug -optimize -target:library -out:Test/DocTest-DropNS-unified-deletetest.dll Test/DocTest-DropNS-unified.cs /define:DELETETEST,V2

Test/DocTest-DropNS-classic-deletetest.dll:
	rm -f Test/DocTest-DropNS-classic-deletetest.dll
	$(CSCOMPILE) $(TEST_CSCFLAGS) -unsafe -debug -optimize -target:library -out:$@ Test/DocTest-DropNS-classic.cs /define:DELETETEST

Test/DocTest-DropNS-classic-deletetest-V2.dll:
	rm -f Test/DocTest-DropNS-classic-deletetest.dll
	$(CSCOMPILE) $(TEST_CSCFLAGS) -unsafe -debug -optimize -target:library -out:Test/DocTest-DropNS-classic-deletetest.dll Test/DocTest-DropNS-classic.cs /define:DELETETEST,V2

Test/DocTest.dll: 
	$(CSCOMPILE) $(TEST_CSCFLAGS) -debug -optimize -unsafe -target:library -out:$@ Test/DocTest.cs -r:System.Core.dll -r:Microsoft.CSharp.dll

Test/DocTest-InternalInterface.dll: 
	$(CSCOMPILE) $(TEST_CSCFLAGS) -unsafe -debug -optimize -target:library -out:$@ Test/DocTest-InternalInterface.cs

Test/DocTest-framework-inheritance-one.dll:
	$(CSCOMPILE) $(TEST_CSCFLAGS) -unsafe -debug -optimize -target:library -out:$@ Test/DocTest-framework-inheritance.cs /define:FXONE

Test/DocTest-framework-inheritance-two.dll:
	$(CSCOMPILE) $(TEST_CSCFLAGS) -unsafe -debug -optimize -target:library -out:$@ Test/DocTest-framework-inheritance.cs /define:FXTWO

Test/DocTest.dll-v1: 
	-rm -f Test/DocTest.cs
	cp Test/DocTest-v1.cs Test/DocTest.cs
	-rm -f Test/DocTest.dll
	$(MAKE) Test/DocTest.dll

Test/DocTest.dll-v2: 
	-rm -f Test/DocTest.cs
	cp Test/DocTest-v1.cs Test/DocTest.cs
	cd Test && patch -p0 < DocTest-v2.patch
	-rm -f Test/DocTest.dll
	$(MAKE) Test/DocTest.dll

Test/DocTest-enumerations.dll: 
	$(CSCOMPILE) $(TEST_CSCFLAGS) -unsafe -debug -optimize -target:library -out:$@ Test/DocTest-enumerations.cs
	
Test/DocTest-embedded-type.dll: 
	$(CSCOMPILE) $(TEST_CSCFLAGS) -unsafe -debug -optimize -target:library -out:$@ Test/DocTest-embedded-type.cs

Test/DocTest-typeForwards-First.dll:
	rm -f $@
	$(CSCOMPILE) $(TEST_CSCFLAGS) -unsafe -debug -optimize -target:library -out:$@ Test/DocTest-typeForwards.cs /define:FIRST

.PHONY: Test/DocTest-typeForwards-Second.dll
Test/DocTest-typeForwards-Second.dll:
	rm -f $@
	rm -f Test/DocTest-typeForwards-Second-First.dll
	$(CSCOMPILE) $(TEST_CSCFLAGS) -unsafe -debug -optimize -target:library -out:$@ Test/DocTest-typeForwards.cs /define:FIRST
	$(CSCOMPILE) $(TEST_CSCFLAGS) -unsafe -debug -optimize -target:library -out:Test/DocTest-typeForwards-Second-First.dll /reference:$@ Test/DocTest-typeForwards.cs /define:SECOND

.PHONY: Test/FrameworkTestData
Test/FrameworkTestData: Test/DocTest-addNonGeneric.dll Test/DocTest-DropNS-classic.dll Test/DocTest-DropNS-classic-secondary.dll
	rm -rf Test/FrameworkTestData
	mkdir Test/FrameworkTestData
	mkdir Test/FrameworkTestData/One
	mkdir Test/FrameworkTestData/Two
	cp Test/DocTest-addNonGeneric.dll Test/FrameworkTestData/One/
	cp Test/DocTest-DropNS-classic.dll Test/FrameworkTestData/One/
	cp Test/DocTest-addNonGeneric.dll Test/FrameworkTestData/Two/
	cp Test/DocTest-DropNS-classic-secondary.dll Test/FrameworkTestData/Two/
	$(MONO) $(PROGRAM) fx-bootstrap Test/FrameworkTestData

Test/FrameworkTestData-fx-inheritance: Test/DocTest-framework-inheritance-one.dll Test/DocTest-framework-inheritance-two.dll
	rm -rf Test/FrameworkTestData-fx-inheritance
	mkdir Test/FrameworkTestData-fx-inheritance
	mkdir Test/FrameworkTestData-fx-inheritance/One
	mkdir Test/FrameworkTestData-fx-inheritance/Two
	cp Test/DocTest-framework-inheritance-one.dll Test/FrameworkTestData-fx-inheritance/One/
	cp Test/DocTest-framework-inheritance-two.dll Test/FrameworkTestData-fx-inheritance/Two/
	$(MONO) $(PROGRAM) fx-bootstrap Test/FrameworkTestData-fx-inheritance

.PHONY: check-monodocer-typeForwards
check-monodocer-typeForwards : Test/DocTest-typeForwards-First.dll Test/DocTest-typeForwards-Second.dll
	-rm -Rf Test/en.actual

	# set up the fx test data
	-rm -Rf Test/FrameworkTestData-fx-typeForwards
	mkdir Test/FrameworkTestData-fx-typeForwards
	mkdir Test/FrameworkTestData-fx-typeForwards/One
	mkdir Test/FrameworkTestData-fx-typeForwards/Two
	mkdir Test/FrameworkTestData-fx-typeForwards/dependencies
	mkdir Test/FrameworkTestData-fx-typeForwards/dependencies/Two
	cp Test/DocTest-typeForwards-First.dll Test/FrameworkTestData-fx-typeForwards/One
	cp Test/DocTest-typeForwards-Second-First.dll Test/FrameworkTestData-fx-typeForwards/Two
	cp Test/DocTest-typeForwards-Second.dll Test/FrameworkTestData-fx-typeForwards/dependencies/Two
	$(MONO) $(PROGRAM) fx-bootstrap Test/FrameworkTestData-fx-typeForwards

	# now run mdoc update
	$(MONO) $(PROGRAM) update -o Test/en.actual -frameworks Test/FrameworkTestData-fx-typeForwards
	$(DIFF) Test/en.expected.typeForwards Test/en.actual

check-monodocer-frameworks: Test/FrameworkTestData
	-rm -Rf Test/en.actual
	$(MONO) $(PROGRAM) update -o Test/en.actual -frameworks Test/FrameworkTestData
	$(DIFF) Test/en.expected-frameworks Test/en.actual

check-monodocer-frameworks-inheritance: Test/FrameworkTestData-fx-inheritance
	-rm -Rf Test/en.actual
	$(MONO) $(PROGRAM) update -o Test/en.actual -frameworks Test/FrameworkTestData-fx-inheritance
	$(DIFF) Test/en.expected-frameworks-inheritance Test/en.actual
	
check-monodocer-frameworks-with-nuget: 
	-rm -Rf Test/en.actual
	-rm -rf Test/test-nuget-information/input_data
	mkdir Test/test-nuget-information/input_data
	mkdir Test/test-nuget-information/input_data/One
	mkdir Test/test-nuget-information/input_data/Two
	cp Test/DocTest-addNonGeneric.dll Test/test-nuget-information/input_data/One/
	cp Test/DocTest-DropNS-classic.dll Test/test-nuget-information/input_data/One/
	cp Test/DocTest-addNonGeneric.dll Test/test-nuget-information/input_data/Two/
	cp Test/DocTest-DropNS-classic-secondary.dll Test/test-nuget-information/input_data/Two/
	cp Test/frameworks.xml Test/test-nuget-information/input_data/
	$(MONO) $(PROGRAM) update -o Test/en.actual -frameworks Test/test-nuget-information/input_data
	$(DIFF) Test/test-nuget-information/en.expected-frameworks-with-nuget-information Test/en.actual

check-monodocer-docid: Test/FrameworkTestData
	-rm -Rf Test/en.actual
	$(MONO) $(PROGRAM) update -use-docid -o Test/en.actual -frameworks Test/FrameworkTestData
	$(DIFF) Test/en.expected-docid Test/en.actual
	
check-monodocer-vbnet: Test/FrameworkTestData
	-rm -Rf Test/en.actual
	$(MONO) $(PROGRAM) update -lang vb.net -o Test/en.actual -frameworks Test/FrameworkTestData
	$(DIFF) Test/en.expected-vbnet Test/en.actual

check-monodocer-Eii: 
	-rm -Rf Test/en.actual
	$(MAKE) Test/DocTest-VB-Eii.dll
	$(MONO) $(PROGRAM) update -o Test/en.actual Test/DocTest-VB-Eii.dll -lang vb.net -lang fsharp -lang javascript -lang c++/cli -lang c++/cx -lang c++/winrt
	$(DIFF) Test/en.expected-eii-implementation Test/en.actual	
	
check-monodocer-Eii-importecmadoc-oldNames: 
	-rm -Rf Test/en.actual
	$(MAKE) Test/DocTest-VB-Eii.dll
	$(MONO) $(PROGRAM) update -o Test/en.actual Test/DocTest-VB-Eii.dll -lang vb.net -lang fsharp -lang javascript -lang c++/cli -lang c++/cx -lang c++/winrt -import Test/ClassEnumeratorECMA.xml
	$(DIFF) Test/en.expected-eii-implementation-ecmadoc Test/en.actual	
	
check-monodocer-Eii-importslashdoc: 
	-rm -Rf Test/en.actual
	$(MAKE) Test/DocTest-VB-Eii.dll	
	$(MONO) $(PROGRAM) update -o Test/en.actual Test/DocTest-VB-Eii.dll -lang vb.net -lang fsharp -lang javascript -lang c++/cli -lang c++/cx -lang c++/winrt -import Test/ClassEnumeratorSlashDoc.xml
	$(DIFF) Test/en.expected-eii-implementation-slashdoc Test/en.actual	
	
check-monodocer-cppcli: Test/FrameworkTestData
	-rm -Rf Test/en.actual
	$(MONO) $(PROGRAM) update -lang c++/cli -o Test/en.actual -frameworks Test/FrameworkTestData
	$(DIFF) Test/en.expected-cppcli Test/en.actual

check-monodocer-cppwinrtUwp: 
	-rm -Rf Test/en.actual
	$(MONO) $(PROGRAM) update -lib ../external/Windows --lang c++/winrt -o Test/en.actual Test/UwpTestWinRtComponentCpp.winmd
	$(DIFF) Test/ex.expected-cppwinrtuwp Test/en.actual
	
check-monodocer-cppcx: Test/FrameworkTestData
	-rm -Rf Test/en.actual

=== external/boringssl/crypto/CMakeLists.txt ===
include_directories(../include)

if(NOT OPENSSL_NO_ASM)
  if(APPLE)
    if (${ARCH} STREQUAL "x86")
      set(PERLASM_FLAGS "-fPIC -DOPENSSL_IA32_SSE2")
    endif()
    set(PERLASM_STYLE macosx)
    set(ASM_EXT S)
    enable_language(ASM)
  elseif(UNIX AND NOT CYGWIN)
    if (${ARCH} STREQUAL "aarch64")
      # The "armx" Perl scripts look for "64" in the style argument
      # in order to decide whether to generate 32- or 64-bit asm.
      set(PERLASM_STYLE linux64)
    elseif (${ARCH} STREQUAL "arm")
      set(PERLASM_STYLE linux32)
    elseif (${ARCH} STREQUAL "x86")
      set(PERLASM_FLAGS "-fPIC -DOPENSSL_IA32_SSE2")
      set(PERLASM_STYLE elf)
    else()
      set(PERLASM_STYLE elf)
    endif()
    set(ASM_EXT S)
    enable_language(ASM)
    set(CMAKE_ASM_FLAGS "${CMAKE_ASM_FLAGS} -Wa,--noexecstack")
  else()
    if (CMAKE_CL_64 OR (CYGWIN AND ${ARCH} STREQUAL "x86_64"))
      message("Using nasm")
      set(PERLASM_STYLE nasm)
    else()
      message("Using win32n")
      set(PERLASM_STYLE win32n)
      set(PERLASM_FLAGS "-DOPENSSL_IA32_SSE2")
    endif()

    # On Windows, we use the NASM output, specifically built with Yasm.
    set(ASM_EXT asm)
    enable_language(ASM_NASM)
  endif()

  function(perlasm dest src)
    add_custom_command(
      OUTPUT ${dest}
      COMMAND ${PERL_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/${src} ${PERLASM_STYLE} ${PERLASM_FLAGS} ${ARGN} > ${dest}
      DEPENDS
      ${src}
      ${PROJECT_SOURCE_DIR}/crypto/perlasm/arm-xlate.pl
      ${PROJECT_SOURCE_DIR}/crypto/perlasm/x86_64-xlate.pl
      ${PROJECT_SOURCE_DIR}/crypto/perlasm/x86asm.pl
      ${PROJECT_SOURCE_DIR}/crypto/perlasm/x86gas.pl
      ${PROJECT_SOURCE_DIR}/crypto/perlasm/x86masm.pl
      ${PROJECT_SOURCE_DIR}/crypto/perlasm/x86nasm.pl
      WORKING_DIRECTORY .
    )
  endfunction()
else()
  function(perlasm dest src)
    # Disabled since OPENSSL_NO_ASM has been defined.
  endfunction()
endif()

# Level 0.1 - depends on nothing outside this set.
add_subdirectory(stack)
add_subdirectory(lhash)
add_subdirectory(err)
add_subdirectory(buf)
add_subdirectory(base64)
add_subdirectory(bytestring)

# Level 0.2 - depends on nothing but itself
add_subdirectory(sha)
add_subdirectory(md4)
add_subdirectory(md5)
add_subdirectory(modes)
add_subdirectory(aes)
add_subdirectory(des)
add_subdirectory(rc4)
add_subdirectory(conf)
add_subdirectory(chacha)
add_subdirectory(poly1305)
add_subdirectory(curve25519)
add_subdirectory(newhope)

# Level 1, depends only on 0.*
add_subdirectory(digest)
add_subdirectory(cipher)
add_subdirectory(rand)
add_subdirectory(bio)
add_subdirectory(bn)
add_subdirectory(obj)
add_subdirectory(asn1)

# Level 2
add_subdirectory(engine)
add_subdirectory(dh)
add_subdirectory(dsa)
add_subdirectory(rsa)
add_subdirectory(ec)
add_subdirectory(ecdh)
add_subdirectory(ecdsa)
add_subdirectory(hmac)

# Level 3
add_subdirectory(cmac)
add_subdirectory(evp)
add_subdirectory(hkdf)
add_subdirectory(pem)
add_subdirectory(x509)
add_subdirectory(x509v3)

# Level 4
add_subdirectory(pkcs8)

# Test support code
if(ENABLE_TESTS)
add_subdirectory(test)
endif()

set(
  crypto_objects_dependencies
  $<TARGET_OBJECTS:stack>
  $<TARGET_OBJECTS:lhash>
  $<TARGET_OBJECTS:err>
  $<TARGET_OBJECTS:base64>
  $<TARGET_OBJECTS:bytestring>
  $<TARGET_OBJECTS:sha>
  $<TARGET_OBJECTS:md4>
  $<TARGET_OBJECTS:md5>
  $<TARGET_OBJECTS:digest>
  $<TARGET_OBJECTS:cipher>
  $<TARGET_OBJECTS:modes>
  $<TARGET_OBJECTS:aes>
  $<TARGET_OBJECTS:des>
  $<TARGET_OBJECTS:rc4>
  $<TARGET_OBJECTS:conf>
  $<TARGET_OBJECTS:chacha>
  $<TARGET_OBJECTS:poly1305>
  $<TARGET_OBJECTS:curve25519>
  $<TARGET_OBJECTS:buf>
  $<TARGET_OBJECTS:bn>
  $<TARGET_OBJECTS:bio>
  $<TARGET_OBJECTS:rand>
  $<TARGET_OBJECTS:obj>
  $<TARGET_OBJECTS:asn1>
  $<TARGET_OBJECTS:engine>
  $<TARGET_OBJECTS:dh>
  $<TARGET_OBJECTS:dsa>
  $<TARGET_OBJECTS:rsa>
  $<TARGET_OBJECTS:ec>
  $<TARGET_OBJECTS:ecdh>
  $<TARGET_OBJECTS:ecdsa>
  $<TARGET_OBJECTS:hmac>
  $<TARGET_OBJECTS:cmac>
  $<TARGET_OBJECTS:evp>
  $<TARGET_OBJECTS:hkdf>
  $<TARGET_OBJECTS:pem>
  $<TARGET_OBJECTS:x509>
  $<TARGET_OBJECTS:x509v3>
  $<TARGET_OBJECTS:pkcs8_lib>
  $<TARGET_OBJECTS:newhope>
  PARENT_SCOPE
)

add_library(
  crypto-objects OBJECT

  cpu-aarch64-linux.c
  cpu-arm.c
  cpu-arm-linux.c
  cpu-intel.c
  crypto.c
  ex_data.c
  mem.c
  refcount_c11.c
  refcount_lock.c
  thread.c
  thread_none.c
  thread_pthread.c
  thread_win.c
  time_support.c

  ${CRYPTO_ARCH_SOURCES}
)



add_library(
  crypto

  cpu-aarch64-linux.c
  cpu-arm.c
  cpu-arm-linux.c
  cpu-intel.c
  crypto.c
  ex_data.c
  mem.c
  refcount_c11.c
  refcount_lock.c
  thread.c
  thread_none.c
  thread_pthread.c
  thread_win.c
  time_support.c

  $<TARGET_OBJECTS:stack>
  $<TARGET_OBJECTS:lhash>
  $<TARGET_OBJECTS:err>
  $<TARGET_OBJECTS:base64>
  $<TARGET_OBJECTS:bytestring>
  $<TARGET_OBJECTS:sha>
  $<TARGET_OBJECTS:md4>
  $<TARGET_OBJECTS:md5>
  $<TARGET_OBJECTS:digest>
  $<TARGET_OBJECTS:cipher>
  $<TARGET_OBJECTS:modes>
  $<TARGET_OBJECTS:aes>
  $<TARGET_OBJECTS:des>
  $<TARGET_OBJECTS:rc4>
  $<TARGET_OBJECTS:conf>
  $<TARGET_OBJECTS:chacha>
  $<TARGET_OBJECTS:poly1305>
  $<TARGET_OBJECTS:curve25519>
  $<TARGET_OBJECTS:buf>
  $<TARGET_OBJECTS:bn>
  $<TARGET_OBJECTS:bio>
  $<TARGET_OBJECTS:rand>
  $<TARGET_OBJECTS:obj>
  $<TARGET_OBJECTS:asn1>
  $<TARGET_OBJECTS:engine>
  $<TARGET_OBJECTS:dh>
  $<TARGET_OBJECTS:dsa>
  $<TARGET_OBJECTS:rsa>
  $<TARGET_OBJECTS:ec>
  $<TARGET_OBJECTS:ecdh>
  $<TARGET_OBJECTS:ecdsa>
  $<TARGET_OBJECTS:hmac>
  $<TARGET_OBJECTS:cmac>
  $<TARGET_OBJECTS:evp>
  $<TARGET_OBJECTS:hkdf>
  $<TARGET_OBJECTS:pem>
  $<TARGET_OBJECTS:x509>
  $<TARGET_OBJECTS:x509v3>
  $<TARGET_OBJECTS:pkcs8_lib>
  $<TARGET_OBJECTS:newhope>
)

if(NOT MSVC AND NOT ANDROID)
  target_link_libraries(crypto pthread)
endif()

if(ENABLE_TESTS)
add_executable(
  constant_time_test

  constant_time_test.c

  $<TARGET_OBJECTS:test_support>
)

target_link_libraries(constant_time_test crypto)
add_dependencies(all_tests constant_time_test)

add_executable(
  thread_test

  thread_test.c

  $<TARGET_OBJECTS:test_support>
)

target_link_libraries(thread_test crypto)
add_dependencies(all_tests thread_test)

add_executable(
  refcount_test

  refcount_test.c
)

target_link_libraries(refcount_test crypto)
add_dependencies(all_tests refcount_test)
endif()

=== external/boringssl/ssl/CMakeLists.txt ===
include_directories(../include)

add_subdirectory(pqueue)

set(
  ssl_objects_dependencies
  $<TARGET_OBJECTS:pqueue>
  PARENT_SCOPE
)

add_library(
  ssl-objects OBJECT

  custom_extensions.c
  handshake_server.c
  handshake_client.c
  d1_both.c
  d1_lib.c
  d1_meth.c
  d1_pkt.c
  d1_srtp.c
  dtls_record.c
  s3_both.c
  s3_enc.c
  s3_lib.c
  s3_meth.c
  s3_pkt.c
  ssl_aead_ctx.c
  ssl_asn1.c
  ssl_buffer.c
  ssl_cert.c
  ssl_cipher.c
  ssl_ecdh.c
  ssl_file.c
  ssl_lib.c
  ssl_rsa.c
  ssl_session.c
  ssl_stat.c
  t1_enc.c
  t1_lib.c
  tls_record.c
)

add_library(
  ssl

  custom_extensions.c
  handshake_server.c
  handshake_client.c
  d1_both.c
  d1_lib.c
  d1_meth.c
  d1_pkt.c
  d1_srtp.c
  dtls_record.c
  s3_both.c
  s3_enc.c
  s3_lib.c
  s3_meth.c
  s3_pkt.c
  ssl_aead_ctx.c
  ssl_asn1.c
  ssl_buffer.c
  ssl_cert.c
  ssl_cipher.c
  ssl_ecdh.c
  ssl_file.c
  ssl_lib.c
  ssl_rsa.c
  ssl_session.c
  ssl_stat.c
  t1_enc.c
  t1_lib.c
  tls_record.c

  $<TARGET_OBJECTS:pqueue>
)

target_link_libraries(ssl crypto)

if(ENABLE_TESTS)
add_executable(
  ssl_test

  ssl_test.cc

  $<TARGET_OBJECTS:test_support>
)

target_link_libraries(ssl_test ssl crypto)
add_dependencies(all_tests ssl_test)
endif()

=== mcs/class/Microsoft.VisualC/Makefile ===
thisdir = class/Microsoft.VisualC
SUBDIRS = 
include ../../build/rules.make

LIBRARY = Microsoft.VisualC.dll
LIB_REFS = System
KEYFILE = ../msfinal.pub

NO_TEST = yes

include ../../build/library.make

=== mcs/class/Mono.CodeContracts/Makefile ===
thisdir = class/Mono.CodeContracts
SUBDIRS = 
include ../../build/rules.make

LIBRARY = Mono.CodeContracts.dll

LIB_REFS = System System.Core Mono.Cecil Mono.Cecil.Mdb
KEYFILE = ../mono.pub
LIB_MCS_FLAGS = -nowarn:618

TEST_MCS_FLAGS =
TEST_LIB_REFS = System.Core

include ../../build/library.make

=== mcs/class/Mono.Debugger.Soft/Makefile ===
thisdir = class/Mono.Debugger.Soft
include ../../build/rules.make

LIBRARY = Mono.Debugger.Soft.dll
LIBRARY_SNK = ../mono.snk

LIB_REFS = System Mono.Cecil System.Core
LIB_MCS_FLAGS = /unsafe -D:MONO_DATACONVERTER_STATIC_METHODS -D:ENABLE_CECIL /publicsign
KEYFILE = $(LIBRARY_SNK)

ifndef MCS_MODE
DTEST_APP_FLAGS = -langversion:preview
endif

TEST_LIB_REFS = Mono.Cecil System System.Core

ifneq ($(filter monodroid monotouch monotouch_tv monotouch_watch wasm net_4_x,$(PROFILE)),)
test-local: build-dtest
endif

ifneq ($(filter monodroid monotouch monotouch_tv monotouch_watch wasm,$(PROFILE)),)
NO_INSTALL=1
NO_BUILD=1
NO_TEST=1
endif

test_output_dir=$(topdir)/class/lib/$(PROFILE)/tests

$(test_output_dir):
	mkdir -p $@

build-dtest: $(test_output_dir)/dtest-app.exe $(test_output_dir)/dtest-excfilter.exe $(test_output_dir)/dtest-app-opt.exe

$(test_output_dir)/dtest-excfilter.exe: Test/dtest-excfilter.il | $(test_output_dir)
	$(ILASM) -out:$@ /exe /debug Test/dtest-excfilter.il

$(test_output_dir)/dtest-app.exe: Test/dtest-app.cs $(TEST_HELPERS_SOURCES) | $(test_output_dir)
	$(CSCOMPILE) -r:$(topdir)/class/lib/$(PROFILE)/mscorlib.dll -r:$(topdir)/class/lib/$(PROFILE)/System.Core.dll -r:$(topdir)/class/lib/$(PROFILE)/System.dll -r:$(topdir)/class/lib/$(PROFILE)/System.Runtime.CompilerServices.Unsafe.dll -sourcelink:Test/sourcelink.json -out:$@ -unsafe $(PLATFORM_DEBUG_FLAGS) $(DTEST_APP_FLAGS) -optimize- Test/dtest-app.cs $(TEST_HELPERS_SOURCES)

$(test_output_dir)/dtest-app-opt.exe: Test/dtest-app-opt.cs $(TEST_HELPERS_SOURCES) | $(test_output_dir)
	$(CSCOMPILE) -r:$(topdir)/class/lib/$(PROFILE)/mscorlib.dll -r:$(topdir)/class/lib/$(PROFILE)/System.Core.dll -r:$(topdir)/class/lib/$(PROFILE)/System.dll -sourcelink:Test/sourcelink.json -out:$@ -unsafe $(PLATFORM_DEBUG_FLAGS) $(DTEST_APP_FLAGS) -optimize+ Test/dtest-app-opt.cs $(TEST_HELPERS_SOURCES)

TEST_HELPERS_SOURCES = \
	../test-helpers/NetworkHelpers.cs \
	Test/TypeLoadClass.cs

EXTRA_DISTFILES = \
	Test/dtest-app.cs \
	Test/dtest.cs \
	Test/dtest-excfilter.il \
	Test/sourcelink.json \
	$(TEST_HELPERS_SOURCES)

CLEAN_FILES = $(addprefix $(test_output_dir)/, dtest-app.exe dtest-app.exe.mdb dtest-app.pdb dtest-excfilter.exe dtest-excfilter.exe.mdb dtest-excfilter.pdb)

include ../../build/library.make

=== mcs/class/Mono.Security.Win32/Makefile ===
thisdir = class/Mono.Security.Win32
SUBDIRS = 
include ../../build/rules.make

LIBRARY = Mono.Security.Win32.dll
KEYFILE = ../mono.pub
LIB_MCS_FLAGS = /unsafe
EXTRA_DISTFILES = README

ifneq (win32, $(PROFILE))
NO_TEST = yes
endif

include ../../build/library.make

=== mcs/class/Mono.Simd/Makefile ===
thisdir = class/Mono.Simd
SUBDIRS = 
include ../../build/rules.make

LIBRARY = Mono.Simd.dll
LIB_REFS = System.Core
KEYFILE = ../mono.pub
LIB_MCS_FLAGS = /unsafe

NO_TEST = yes

include ../../build/library.make

=== mcs/class/System.ComponentModel.Composition.4.5/Makefile ===
thisdir = class/System.ComponentModel.Composition.4.5
SUBDIRS = 
include ../../build/rules.make

LIBRARY = System.ComponentModel.Composition.dll
LIB_REFS = System System.Core

NO_RESGEN := $(filter build, $(PROFILE))
ifndef NO_RESGEN
  RESOURCE_DEFS = Microsoft.Internal.Strings,src/ComponentModel/Strings.resx
endif

KEYFILE = ../ecma.pub
LIB_MCS_FLAGS = -d:CLR40 -d:USE_ECMA_KEY,FEATURE_REFLECTIONCONTEXT,FEATURE_REFLECTIONFILEIO,FEATURE_SERIALIZATION,FEATURE_SLIMLOCK -nowarn:219,414 -nowarn:436

XTEST_LIB_REFS = System System.Core System.Xml Facades/System.Threading.Tasks
XTEST_LIB_FLAGS := /keyfile:../mono.snk

RESX_RESOURCE_STRING = \
	../../../external/corefx/src/System.ComponentModel.Composition/src/Resources/Strings.resx

CLEAN_FILES += $(STRING_MESSAGES)

EXTRA_DISTFILES = \
	src/ComponentModel/Strings.resx

include ../../build/library.make

=== mcs/class/System.Data.Services.Client/Makefile ===
thisdir = class/System.Data.Services.Client
SUBDIRS = 
include ../../build/rules.make

LIBRARY = System.Data.Services.Client.dll

RESOURCE_DEFS = System.Data.Services.Client,Client/System.Data.Services.Client.txt

LIB_REFS = System System.Core System.Xml.Linq System.Data System.Xml
KEYFILE = ../ecma.pub
LIB_MCS_FLAGS = \
	-d:NET_3_5	\
	-warn:2

ifndef NO_WINDOWS_BASE
ifneq (2.1, $(FRAMEWORK_VERSION))
LIB_REFS += WindowsBase
endif
endif

include ../../build/library.make

EXTRA_DISTFILES = Client/System.Data.Services.Client.txt

=== debian/changelog ===
mono (6.14.1+ds-2) unstable; urgency=medium

  * Add missing authors in debian/copyright.
  * Update packages descriptions.

 -- Antoine Le Gonidec <vv221@debian.org>  Wed, 13 Aug 2025 15:33:21 +0200

mono (6.14.1+ds-1) unstable; urgency=medium

  * Switch to new WineHQ upstream.
    (Closes: #1092582)
  * New ustream release.
  * Stop listing symbols for libmonosgen-2.0.so.1.

 -- Antoine Le Gonidec <vv221@debian.org>  Wed, 13 Aug 2025 13:11:22 +0200

=== debian/control ===
Source: mono
Section: cli-mono
Priority: optional
Maintainer: Antoine Le Gonidec <vv221@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-python,
               dpkg-dev (>= 1.16.1~),
               bison,
               cmake,
               dc,
               libkrb5-dev,
               libx11-dev,
               libxml-dom-perl,
               libxslt1-dev,
               libxt-dev,
               lsb-release,
               procps,
               python3,
               tzdata,
               zlib1g-dev
Rules-Requires-Root: no
Standards-Version: 4.7.2
Homepage: http://www.mono-project.com/
Vcs-Git: https://salsa.debian.org/dotnet-team/mono.git
Vcs-Browser: https://salsa.debian.org/dotnet-team/mono

Package: mono-runtime-common
Provides: cli-runtime, cli-virtual-machine
Architecture: amd64 arm64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 mipsel powerpc ppc64 ppc64el s390x
Replaces: libmono0 (<< 2.4),
          mono-common (<< 2.4),
          mono-jit (<< 2.4),
          mono-runtime (<< 3.2.1)
Conflicts: mono-1.0-runtime (<< 2.4),
           mono-2.0-runtime (<< 2.4),
           mono-common (<< 2.4),
           mono-jit (<< 2.4),
           mono-runtime (<< 3.2.1)
Suggests: xdg-utils | libgnome2-0 | konqueror
Depends: binutils, ${misc:Depends}, ${shlibs:Depends}
Description: Mono runtime - common files
 Framework Mono is a software platform designed to allow developers to easily
 create cross platform applications. It is an open source implementation
 of Microsoft's .NET Framework based on the ECMA standards for C# and the
 Common Language Runtime.
 .
 This package contains common files for the Virtual Machine, JIT (Just-in-Time)
 and AOT (Ahead-of-Time) code generator "mono".
 "mono" executes applications for the CLI (Common Language Infrastructure).
 Mono currently only supports the X86, PowerPC, ARM, S/390x, AMD64 and
 MIPS architectures. Optionally this package configures BINFMT support.

Package: mono-runtime
Architecture: amd64 arm64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 mipsel powerpc ppc64 ppc64el s390x
Depends: libmono-corlib4.5-cil,
         mono-runtime-sgen (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: binfmt-support (>= 1.1.2)
Description: Mono runtime - default version
 Framework Mono is a software platform designed to allow developers to easily
 create cross platform applications. It is an open source implementation
 of Microsoft's .NET Framework based on the ECMA standards for C# and the
 Common Language Runtime.
 .
 This package contains the Virtual Machine, JIT (Just-in-Time) and
 AOT (Ahead-of-Time) code generator "mono-sgen".
 mono-sgen executes applications for the CLI (Common Language Infrastructure).
 Mono currently only supports the X86, PowerPC, ARM, S/390x, AMD64 and
 MIPS architectures.
 .
 This package installs this architecture's default runtime version.

Package: mono-runtime-sgen
Architecture: amd64 arm64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 mipsel powerpc ppc64 ppc64el s390x
Depends: mono-gac (= ${source:Version}),
         mono-runtime-common (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Homepage: http://www.mono-project.com/Compacting_GC
Description: Mono runtime - Using SGen garbage collector
 Framework Mono is a software platform designed to allow developers to easily
 create cross platform applications. It is an open source implementation
 of Microsoft's .NET Framework based on the ECMA standards for C# and the
 Common Language Runtime.
 .
 This package contains the Virtual Machine, JIT (Just-in-Time) and
 AOT (Ahead-of-Time) code generator "mono-sgen".
 mono-sgen executes applications for the CLI (Common Language Infrastructure).
 Mono currently only supports the X86, PowerPC, ARM, S/390x, AMD64 and
 MIPS architectures.
 .
 This package uses SGen which is Mono's new simple generational garbage
 collector.

Package: mono-runtime-boehm
Architecture: amd64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 mipsel powerpc ppc64 ppc64el s390x
Depends: mono-gac (= ${source:Version}),
         mono-runtime-common (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Mono runtime - Using Boehm's garbage collector
 Framework Mono is a software platform designed to allow developers to easily
 create cross platform applications. It is an open source implementation
 of Microsoft's .NET Framework based on the ECMA standards for C# and the
 Common Language Runtime.
 .
 This package contains the Virtual Machine, JIT (Just-in-Time) and
 AOT (Ahead-of-Time) code generator "mono-sgen".
 mono-sgen executes applications for the CLI (Common Language Infrastructure).
 Mono currently only supports the X86, PowerPC, ARM, S/390x, AMD64 and
 MIPS architectures.
 .
 This package uses Boehm's conservative garbage collector.

Package: mono-runtime-dbg
Priority: optional
Section: debug
Architecture: amd64 arm64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 mipsel powerpc ppc64 ppc64el s390x
Replaces: mono-jit-dbg (<< 2.4)
Conflicts: mono-jit-dbg (<< 2.4)
Depends: mono-runtime-boehm (= ${binary:Version}) [amd64 armel armhf i386 mipsel kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 ppc64el s390x],
         mono-runtime-sgen (= ${binary:Version}),
         ${misc:Depends}
Recommends: gdb
Description: Mono runtime, debugging symbols
 Framework Mono is a software platform designed to allow developers to easily
 create cross platform applications. It is an open source implementation
 of Microsoft's .NET Framework based on the ECMA standards for C# and the
 Common Language Runtime.
 .
 This package contains the debugging symbols of the Mono JIT/AOT compiler.

Package: mono-utils
Provides: cil-disassembler
Architecture: amd64 arm64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 mipsel powerpc ppc64 ppc64el s390x
Replaces: mono-mcs (<= 1.1.6-4)
Depends: libmono-corlib4.5-cil (= ${source:Version}),
         libmonoboehm-2.0-1 (= ${binary:Version}) [amd64 armel armhf i386 mipsel kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 ppc64el s390x],
         ${misc:Depends},
         ${shlibs:Depends}
Description: Mono utilities
 Framework Mono is a software platform designed to allow developers to easily
 create cross platform applications. It is an open source implementation
 of Microsoft's .NET Framework based on the ECMA standards for C# and the
 Common Language Runtime.
 .
 This package includes various tools useful for CLI developers, like
 pedump, monodis and monograph.

Package: ca-certificates-mono
Architecture: all
Pre-Depends: mono-runtime-common (>= 5.20)
Depends: ca-certificates (>= 20121114),
         ${cli:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Description: Common CA certificates (Mono keystore)
 Framework Mono is a software platform designed to allow developers to easily
 create cross platform applications. It is an open source implementation
 of Microsoft's .NET Framework based on the ECMA standards for C# and the
 Common Language Runtime.
 .
 This package uses the hooks of the ca-certificates package to update the
 Mono keystore.

Package: mono-complete
Architecture: amd64 arm64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 mipsel powerpc ppc64 ppc64el s390x
Depends: ca-certificates-mono (= ${source:Version}),
         libmono-2.0-1 (= ${binary:Version}),
         libmono-cil-dev (= ${source:Version}),
         libmono-profiler (= ${binary:Version}),
         mono-4.0-gac (= ${source:Version}),
         mono-4.0-service (= ${source:Version}),
         mono-csharp-shell (= ${source:Version}),
         mono-devel (= ${source:Version}),
         mono-mcs (= ${source:Version}),
         mono-runtime (= ${binary:Version}),
         mono-runtime-sgen (= ${binary:Version}),
         mono-utils (= ${binary:Version}),
         monodoc-base (= ${source:Version}),
         monodoc-manual (= ${source:Version}),
         ${misc:Depends}
Description: complete Mono runtime, development tools and all libraries
 Framework Mono is a software platform designed to allow developers to easily
 create cross platform applications. It is an open source implementation
 of Microsoft's .NET Framework based on the ECMA standards for C# and the
 Common Language Runtime.
 .
 This is a metapackage and pulls in the Mono runtime, development tools and
 all libraries.
 .
 Install this package if you want to run software for Mono or Microsoft .NET
 which you are not installing from a Debian package.
 .
 For packagers: This package is not to be used as dependency for packages!
 You should build-depend on cli-common-dev and the needed libraries instead.

Package: libmono-2.0-1
Architecture: amd64 arm64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 mipsel powerpc ppc64 ppc64el s390x
Replaces: libmono-dev (<= 1.1.6-4)
Conflicts: mono-utils (<< 1.2.3.1-4)
Depends: libmonosgen-2.0-1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Mono JIT library (Default version)
 Framework Mono is a software platform designed to allow developers to easily
 create cross platform applications. It is an open source implementation
 of Microsoft's .NET Framework based on the ECMA standards for C# and the
 Common Language Runtime.
 .
 Shared library for Mono, used for embedding/hosting of the JIT.

Package: libmono-2.0-dev
Architecture: amd64 arm64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 mipsel powerpc ppc64 ppc64el s390x
Depends: libmonosgen-2.0-dev (= ${binary:Version}), ${misc:Depends}
Description: Mono JIT library - Development files (Default version)
 Framework Mono is a software platform designed to allow developers to easily
 create cross platform applications. It is an open source implementation
 of Microsoft's .NET Framework based on the ECMA standards for C# and the
 Common Language Runtime.
 .
 Header files and static libraries for libmono-2.0.

Package: libmonosgen-2.0-1
Architecture: amd64 arm64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 mipsel powerpc ppc64 ppc64el s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Mono JIT library (SGen GC)
 Framework Mono is a software platform designed to allow developers to easily
 create cross platform applications. It is an open source implementation
 of Microsoft's .NET Framework based on the ECMA standards for C# and the
 Common Language Runtime.
 .
 Shared library for Mono, used for embedding/hosting of the JIT.

Package: libmonosgen-2.0-1-dbg
Priority: optional
Section: debug
Architecture: amd64 arm64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 mipsel powerpc ppc64 ppc64el s390x
Depends: libmonosgen-2.0-1 (= ${binary:Version}), ${misc:Depends}
Recommends: gdb
Description: Mono JIT library, debugging symbols (SGen GC)
 Framework Mono is a software platform designed to allow developers to easily
 create cross platform applications. It is an open source implementation
 of Microsoft's .NET Framework based on the ECMA standards for C# and the
 Common Language Runtime.
 .
 This package contains the debugging symbols of the Mono JIT library.

Package: libmonosgen-2.0-dev
Architecture: amd64 arm64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 mipsel powerpc ppc64 ppc64el s390x
Depends: libmonosgen-2.0-1 (= ${binary:Version}), ${misc:Depends}
Description: Mono JIT library - Development files (SGen GC)
 Framework Mono is a software platform designed to allow developers to easily
 create cross platform applications. It is an open source implementation
 of Microsoft's .NET Framework based on the ECMA standards for C# and the
 Common Language Runtime.
 .
 Header files and static libraries for libmonosgen-2.0.

Package: libmonoboehm-2.0-1
Architecture: amd64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 mipsel powerpc ppc64 ppc64el s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Mono JIT library (Boehm GC)
 Framework Mono is a software platform designed to allow developers to easily

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

# bring in VERSION/ARCH/BUILD variables
include /usr/share/dpkg/default.mk
include debian/mono-archs.make

UPVERSION = $(subst +ds,,$(DEB_VERSION_UPSTREAM))
NEXT_UPVERSION = $(shell perl -e '$$_=pop; s/(\d+)$$/$$1+1/e; print' $(UPVERSION))

RUN_MONO = MONO_PATH=debian/tmp/usr/lib/mono/4.5 runtime/mono-wrapper
KILL_MONO = pgrep mono | xargs kill -9
DH_INTERNAL_MONO_PARAM = --internal-mono

ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
	CONF_FLAGS += --build $(DEB_HOST_GNU_TYPE)
else
	CONF_FLAGS += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif

ifeq ($(DEB_HOST_ARCH_OS), kfreebsd)
	CONF_FLAGS += --enable-minimal=aot
endif

ifeq ($(DEB_HOST_ARCH), armel)
	CONF_FLAGS += --with-fpu=NONE --with-tls=pthread
	BTLS_ARCH = true
else ifeq ($(DEB_HOST_ARCH), armhf)
	CONF_FLAGS += --with-tls=pthread
	BTLS_ARCH = true
else ifeq ($(DEB_HOST_ARCH), arm64)
	MONO_BOEHM_TEST = true
	CONF_FLAGS += --disable-boehm
	SKIP_LIBGC = true
	BTLS_ARCH = true
else ifeq ($(DEB_HOST_ARCH), i386)
	BTLS_ARCH = true
else ifeq ($(DEB_HOST_ARCH), amd64)
	BTLS_ARCH = true
else ifeq ($(DEB_HOST_ARCH), mipsel)
	CONF_FLAGS += --with-tls=pthread
else ifeq ($(DEB_HOST_ARCH), powerpc)
	CONF_FLAGS += --with-tls=pthread
else ifeq ($(DEB_HOST_ARCH), ppc64)
	CONF_FLAGS += --with-tls=pthread
else ifeq ($(DEB_HOST_ARCH), ppc64el)
	CONF_FLAGS += --with-tls=pthread
	BTLS_ARCH = true
else ifeq ($(DEB_HOST_ARCH), s390x)
	BTLS_ARCH = true
endif

ifneq (,$(findstring $(DEB_HOST_ARCH),$(DEB_MONO_SGEN_ARCHS)))
	CONF_FLAGS += --with-sgen=yes
else
	CONF_FLAGS += --with-sgen=no
endif


%:
	dh $@ --with=python3


CONFIGURE = --libdir=/usr/lib/ --libexecdir=/usr/lib/ \
	--with-ikvm-native=no --disable-quiet-build --with-csc=mcs \
	--disable-system-aot --enable-llvm=no --enable-loadedllvm=no \
	$(CONF_FLAGS)


ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MONO_MAKE_FLAGS += -j$(NUMJOBS)
endif

override_dh_auto_configure:
	dh_auto_configure -- $(CONFIGURE)

override_dh_auto_build:
	cd mono/eglib && $(MAKE) $(MONO_MAKE_FLAGS)
ifndef SKIP_LIBGC
	cd external/bdwgc && $(MAKE) $(MONO_MAKE_FLAGS)
endif
	cd mono && $(MAKE) $(MONO_MAKE_FLAGS)
	LC_ALL=C $(MAKE) $(MAKE_FLAGS) EXTERNAL_MCS=false EXTERNAL_MONO=false

	cd debian/detector && $(MAKE)
	chmod +x debian/dh_makeclilibs \
	         debian/dh_clideps \
	         debian/dh_clistrip \
	         debian/dh_clifixperms \
	         debian/dh_monoaot
	cp -a ./external/binary-reference-assemblies/v4.7.1 ./external/binary-reference-assemblies/v4.7.1.debbak
	find ./external/binary-reference-assemblies/v4.7.1/ -name \*.dll -print -delete
	MONO_PATH=$(CURDIR)/mcs/class/lib/net_4_x-linux/ $(MAKE) $(MONO_MAKE_FLAGS) -C external/binary-reference-assemblies/ \
		V=$(DH_VERBOSE) CSC="$(CURDIR)/runtime/mono-wrapper $(CURDIR)/mcs/class/lib/net_4_x-linux/mcs.exe"
	# Build the late-GAC tool, using the built Mono runtime
	MONO_PATH=$(CURDIR)/mcs/class/lib/net_4_x-linux/ runtime/mono-wrapper \
		mcs/class/lib/net_4_x-linux/mcs.exe -target:exe \
		-out:debian/MonoGetAssemblyName.exe debian/MonoGetAssemblyName.cs

override_dh_auto_test:
	-cd mono/mini && timeout -k 15m 1h make check; $(KILL_MONO)
	-cd mono/tests && MONO_ENV_OPTIONS="$(MONO_ENV_OPTIONS) --gc=boehm" timeout -k 15m 1h make check; $(KILL_MONO)
	-cd mono/tests && MONO_ENV_OPTIONS="$(MONO_ENV_OPTIONS) --gc=sgen" timeout -k 15m 1h make check; $(KILL_MONO)
	-$(KILL_MONO)
	# funny bug-459094.cs creates too long directory names which
	# pbuilder is unable to remove, eh
	rm -rf mono/tests/abcde12345abcde12345abcde12345abcde12345/

override_dh_auto_clean:
ifneq ("$(wildcard external/binary-reference-assemblies/v4.7.1.debbak)","")
		rm -rf external/binary-reference-assemblies/v4.7.1
		mv external/binary-reference-assemblies/v4.7.1.debbak external/binary-reference-assemblies/v4.7.1
endif
	[ ! -f Makefile ] || $(MAKE) distclean
	# distclean misses stuff
	find -name "*.mdb" -delete
	find ./external/binary-reference-assemblies/ -name "*.dll" -not -path "./external/binary-reference-assemblies/v4.7.1/*" -print -delete
	rm -rf mcs/class/lib/basic/ \
	       mcs/class/lib/net_4_5/
	-cd debian/detector && $(MAKE) clean
	rm -f debian/MonoGetAssemblyName.exe
	rm -f mcs/packages/*.dll mcs/packages/*.exe* mcs/packages/*.rsp
	dh_auto_clean

override_dh_auto_install:
	dh_auto_install
	cd mcs/jay && \
		$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp
	# don't want docs of bundled libgc
	rm -rf debian/tmp/usr/share/libgc-mono
	# Mono.Security.Win32.dll is only useful on windows, as it wrap the win api
	rm -rf $(CURDIR)/debian/tmp/usr/lib/mono/gac/Mono.Security.Win32/
	rm -f  $(CURDIR)/debian/tmp/usr/lib/mono/4.5/Mono.Security.Win32.dll*
	# we don't ship bundled nunit of mono
	rm -f  $(CURDIR)/debian/tmp/usr/lib/mono/4.5/nunit*
	rm -f  $(CURDIR)/debian/tmp/usr/lib/pkgconfig/mono-nunit.pc
	rm -rf $(CURDIR)/debian/tmp/usr/lib/mono/gac/nunit*/
	rm -f  $(CURDIR)/debian/tmp/usr/bin/nunit*
	# mono 2.10.1 bug, prj2make was removed but the start script not
	rm -f $(CURDIR)/debian/tmp/usr/bin/prj2make
	install -D -m 644 debian/cli.binfmt \
		debian/mono-runtime/usr/share/binfmts/cli
ifndef SKIP_LIBGC
	strip --strip-unneeded --remove-section=.comment --remove-section=.note \
		debian/tmp/usr/bin/pedump
endif
ifdef BTLS_ARCH
	install -D -m 644 debian/tmp/usr/lib/libmono-btls-shared.so \
		debian/mono-runtime-common/usr/lib/libmono-btls-shared.so
endif

execute_after_dh_install:
	# Late GAC
	install -D --mode=755 debian/mono.runtime-script debian/mono-gac/usr/share/cli-common/runtimes.d/mono
	install -D --mode=644 \
		--target-directory=debian/libmono-corlib4.5-cil/usr/lib/mono/gac/System.Data/4.0.0.0__b77a5c561934e089/ \
		debian/System.Data.dll.config
	install -D --mode=644 \
		--target-directory=debian/libmono-corlib4.5-cil/usr/lib/mono/gac/System.Drawing/4.0.0.0__b03f5f7f11d50a3a/ \
		debian/System.Drawing.dll.config
	install -D --mode=644 \
		--target-directory=debian/libmono-corlib4.5-cil/usr/lib/mono/gac/System.Windows.Forms/4.0.0.0__b77a5c561934e089/ \
		debian/System.Windows.Forms.dll.config
	install -D --mode=644 \
		--target-directory=debian/libmono-corlib4.5-cil/usr/lib/mono/gac/Mono.Cairo/4.0.0.0__0738eb9f132ed756/ \
		debian/Mono.Cairo.dll.config
	install -D --mode=644 \
		--target-directory=debian/libmono-corlib4.5-cil/usr/lib/mono/gac/Mono.WebBrowser/4.0.0.0__0738eb9f132ed756/ \
		debian/Mono.WebBrowser.dll.config

	debian/dh_clistrip -i --dbg-package=mono-dbg
	debian/dh_clifixperms -i
	DH_AUTOSCRIPTDIR=$(CURDIR)/debian debian/dh_monoaot -i
	debian/dh_makeclilibs -i -m 1.0 $(DH_INTERNAL_MONO_PARAM)
	debian/dh_makeclilibs -p libmono-corlib4.5-cil $(DH_INTERNAL_MONO_PARAM)
	debian/dh_clideps -i -X/usr/lib/mono/2.0-api -X/usr/lib/mono/3.5-api -X/usr/lib/mono/4.0-api -X/usr/lib/mono/4.5.1-api \
		-X/usr/lib/mono/4.5.2-api -X/usr/lib/mono/4.5-api -X/usr/lib/mono/4.6.1-api -X/usr/lib/mono/4.6.2-api \
		-X/usr/lib/mono/4.6-api -X/usr/lib/mono/4.7.1-api -X/usr/lib/mono/4.7.2-api -X/usr/lib/mono/4.7-api \
		-X/usr/lib/mono/4.8-api -l debian/tmp $(DH_INTERNAL_MONO_PARAM)
	#DH_VERBOSE=1 debian/dh_clideps -i -l debian/tmp $(DH_INTERNAL_MONO_PARAM)
	# mono-1.0/2.0-gac needs special runtime dep, to prevent circular dep (mono-runtime <-> mono-1.0/2.0-gac)
	debian/dh_clideps -p mono-4.0-gac -r $(DH_INTERNAL_MONO_PARAM)

override_dh_strip:
	dh_strip -pmono-runtime-common -pmono-runtime-sgen -pmono-runtime-boehm --dbg-package=mono-runtime-dbg
	dh_strip -plibmonoboehm-2.0-1 --dbg-package=libmonoboehm-2.0-1-dbg
	dh_strip -plibmonosgen-2.0-1 --dbg-package=libmonosgen-2.0-1-dbg
	dh_strip -a -Xbin/mono-sgen -Xbin/mono-boehm

override_dh_makeshlibs:
	dh_makeshlibs -a -V
	dh_makeshlibs -plibmonosgen-2.0-1 -V 'libmonosgen-2.0-1 (>= $(UPVERSION))' -- -c4
ifndef SKIP_LIBGC
	dh_makeshlibs -plibmonoboehm-2.0-1 -V 'libmonoboehm-2.0-1 (>= $(UPVERSION))'
endif

# no elves here, skip zipping debug info
override_dh_dwz:

=== debian/watch ===
version=4
opts=dversionmangle=s/\+ds//,repacksuffix=+ds,compression=xz \
	https://dl.winehq.org/mono/sources/mono/mono-([\d\.]+)\.tar\.xz
